/**
 *  Part of chisel based QECE benchmark of FPGA kernels.
 *  Copyright (C) <2021>  <Bruno FERRES>
 *
 *  This program is developped at TIMA, Grenoble.
 *  Please contact Bruno FERRES (bruno.ferres@grenoble-inp.org) or
 *  Olivier MULLER (olivier.muller@univ-grenoble-alpes.fr)
 *  for more informations.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package bench.kernels.fir

import bench.utils.software.Numeric

object FirUtil {
  def defaultCoeffs(isDouble: Boolean): Array[Numeric] = {
    // This coefficients came from http://t-filter.engineerjs.com/ for a low pass filter configured with this parameters
    // :
    // from 0Hz to 1MHz a gain of 1dB (ripple/att : 5dB)
    // from 2MHz to 50MHz (half of the sample frequency a.k.a clock frequency) a gain of 0dB (ripple/att : -40dB)
    if (isDouble) {
      val coeffs = Array[Double](-0.0044705708005038656, -0.0008644750166720182, -0.0009385728752439055,
          -0.0010126707338157927, -0.00108676859238768, -0.001136167164768938, -0.0011855657371501963,
          -0.0012102650233408254, -0.0012349643095314546, -0.0012349643095314546, -0.0012102650233408254,
          -0.0011855657371501963, -0.001136167164768938, -0.001062069306197051, -0.0009879714476251635,
          -0.0008644750166720182, -0.0007162792995282437, -0.00054338429619384, -0.0003457900066688073,
          -0.00012349643095314544, 0.00012349643095314544, 0.00041988786524069455, 0.0007409785857188727,
          0.00108676859238768, 0.0014819571714377454, 0.00190184503667844, 0.0023464321881097637, 0.0028157186257317165,
          0.003334403635734927, 0.0038777879319287674, 0.004445871514313237, 0.005038654382888335, 0.005656136537654062,
          0.006298317978610418, 0.006965198705757404, 0.007656778719095018, 0.008373058018623262, 0.009089337318151505,
          0.009830315903870379, 0.010571294489589251, 0.011312273075308124, 0.012077950947217626, 0.012818929532936498,
          0.013559908118655371, 0.014300886704374243, 0.015017166003902488, 0.01573344530343073, 0.016425025316768347,
          0.01711660533010596, 0.017758786771062317, 0.018376268925828044, 0.01896905179440314, 0.019512436090596982,
          0.020031121100600194, 0.020500407538222146, 0.020944994689653468, 0.021340183268703534, 0.021661273989181714,
          0.02195766542346926, 0.02220465828537555, 0.022402252574900586, 0.022525749005853732, 0.022624546150616247,
          0.022649245436806877, 0.022624546150616247, 0.022525749005853732, 0.022402252574900586, 0.02220465828537555,
          0.02195766542346926, 0.021661273989181714, 0.021340183268703534, 0.020944994689653468, 0.020500407538222146,
          0.020031121100600194, 0.019512436090596982, 0.01896905179440314, 0.018376268925828044, 0.017758786771062317,
          0.01711660533010596, 0.016425025316768347, 0.01573344530343073, 0.015017166003902488, 0.014300886704374243,
          0.013559908118655371, 0.012818929532936498, 0.012077950947217626, 0.011312273075308124, 0.010571294489589251,
          0.009830315903870379, 0.009089337318151505, 0.008373058018623262, 0.007656778719095018, 0.006965198705757404,
          0.006298317978610418, 0.005656136537654062, 0.005038654382888335, 0.004445871514313237, 0.0038777879319287674,
          0.003334403635734927, 0.0028157186257317165, 0.0023464321881097637, 0.00190184503667844,
          0.0014819571714377454, 0.00108676859238768, 0.0007409785857188727, 0.00041988786524069455,
          0.00012349643095314544, -0.00012349643095314544, -0.0003457900066688073, -0.00054338429619384,
          -0.0007162792995282437, -0.0008644750166720182, -0.0009879714476251635, -0.001062069306197051,
          -0.001136167164768938, -0.0011855657371501963, -0.0012102650233408254, -0.0012349643095314546,
          -0.0012349643095314546, -0.0012102650233408254, -0.0011855657371501963, -0.001136167164768938,
          -0.00108676859238768, -0.0010126707338157927, -0.0009385728752439055, -0.0008644750166720182,
          -0.0044705708005038656)
      coeffs.map(coeff => Numeric(coeff))
    } else {
      val coeffs = Array[Int](-181, -35, -38, -41, -44, -46, -48, -49, -50, -50, -49, -48, -46, -43, -40, -35, -29, -22,
          -14, -5, 5, 17, 30, 44, 60, 77, 95, 114, 135, 157, 180, 204, 229, 255, 282, 310, 339, 368, 398, 428, 458, 489,
          519, 549, 579, 608, 637, 665, 693, 719, 744, 768, 790, 811, 830, 848, 864, 877, 889, 899, 907, 912, 916, 917,
          916, 912, 907, 899, 889, 877, 864, 848, 830, 811, 790, 768, 744, 719, 693, 665, 637, 608, 579, 549, 519, 489,
          458, 428, 398, 368, 339, 310, 282, 255, 229, 204, 180, 157, 135, 114, 95, 77, 60, 44, 30, 17, 5, -5, -14, -22,
          -29, -35, -40, -43, -46, -48, -49, -50, -50, -49, -48, -46, -44, -41, -38, -35, -181)
      coeffs.map(coeff => Numeric(coeff))
    }
  }

  /** Generate coefficients for FIR. Gain should be either one (for fixed point coeffs) or a power of two (for
   *  normalized SInt filters)
   *
   *  @param tap
   *    number of taps used in the filter
   *  @param isDouble
   *    type of coeffs
   *  @todo
   *    Build a real generator with kind, fc, ...
   */
  def generate(tap: Int, isDouble: Boolean = true): Array[Numeric] = {
    isDouble match {
      case true  => (0 until tap).map(coeff => Numeric(coeff.toDouble / ((tap * (tap - 1) / 2.0)))).to[Array]
      case false => (0 until tap).map(coeff => Numeric(coeff)).to[Array]
    }
  }
}
